import com.cycling74.max.*;
import com.cycling74.jitter.*;
import java.io.*;

public class trysinusoids  extends MaxObject {
	trysinusoids (Atom[] a) {
		declareInlets(new int[]{DataTypes.ALL});
		declareOutlets(new int[]{DataTypes.ALL, DataTypes.ALL, DataTypes.ALL, DataTypes.ALL});
		createInfoOutlet(false);	}

	
	// little patch by Alexandre Flet (alexf1975 at yahoo.fr)
	
	
	float freq = 1f ; public void  freq (float val){  freq  =val ; }
	float [] freqs  = new float [25]; public void freqs(float[] lfreqs) { freqs=lfreqs ; }
	float [] vols  = new float [25]; public void vols(float[] lvols) { vols=lvols ; }
	float volmin = 0.031623f ; public void  volmin (float val){  volmin  =val ; }
	
	float [] sinu  = new float [25*2];  // parameters for sinusoids~ 
	float [] sinu200  = new float [200*2];  // parameters for sinusoids~ (200 partials version)
	float [] reso  = new float [25*3];  // parameters for resonators~
	//int flag_wait = 0 ;
	
	
	public void calc(int odd) {
		
		for (int i=0 ; i<25 ; i++) {
			sinu[i*2]   =  (i+1)*freq           ;    //freqs[i]*freq ;
			sinu[i*2+1] =  vols[i]*1/(sinu[i*2]/sinu[0]) ;
			if (vols[i]<=volmin) sinu[i*2+1] = 0.000001f ;
			if ((odd==1) && (  ((i+1)/2) - ((float)(i+1))/2 ==0)) {
				sinu[i*2+1] = 0.000001f ;   // can put 0 because the phase sync go away !
			}
			if (sinu[i*2] > 20000f) {
				sinu[i*2] = sinu[i*2]/8f ;
				sinu[i*2+1] = 0.000001f ;  // can put 0 because the phase sync go away !
			}
		}
		outlet(0, sinu) ;
		outlet(3, 7) ; // for version control in max (proof of reinstantiantion)
		
//		for (int i=0 ; i<25 ; i++) {
//			outlet(2, freqs[i]) ;
//		}
	}
	
	public void calc200(int odd) {   // (200 partials version)
		
		for (int i=0 ; i<200 ; i++) {
			
			sinu200[i*2]   =  (i+1)*freq           ;    //freqs[i]*freq ;
			if (i<25){
				sinu200[i*2+1] =   vols[i]*1/(sinu200[i*2]/sinu200[0]) ;
				if (vols[i]<=volmin) sinu200[i*2+1] = 0.000001f ;
			}else{
				sinu200[i*2+1] =   vols[24]*1/(sinu200[i*2]/sinu200[0]) ;  
				if (vols[24]<=volmin) sinu200[i*2+1] = 0.000001f ;
			}
			
			
			if ((odd==1)  && (  ((i+1)/2) - ((float)(i+1))/2 ==0)) {
				sinu200[i*2+1] = 0.000001f ;  // can put 0 because the phase sync go away !
			}
			if (sinu200[i*2] > 20000f) {
				sinu200[i*2] = sinu200[i*2]/8f ;
				sinu200[i*2+1] = 0.000001f ;  // can put 0 because the phase sync go away !
			}
		}
		outlet(0, sinu200) ;
		outlet(3, 8) ; // for version control in max (proof of reinstantiantion)
		
	}
	
}	